/*

NanoTech - a 3d game engine
Copyright (C) 1996  Sean Lane Fuller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Sean Lane Fuller
124 Autumn Lane
Tullahoma, TN 37388
615-393-4550
email: fuller@edge.net

*/

#ifndef __KEYBRD_H

#define __KEYBRD_H

#define KB_A 30
#define KB_B 48
#define KB_C 46
#define KB_D 32
#define KB_E 18
#define KB_F 33
#define KB_G 34
#define KB_H 35
#define KB_I 23
#define KB_J 36
#define KB_K 37
#define KB_L 38
#define KB_M 50
#define KB_N 49
#define KB_O 24
#define KB_P 25
#define KB_Q 16
#define KB_R 19
#define KB_S 31
#define KB_T 20
#define KB_U 22
#define KB_V 47
#define KB_W 17
#define KB_X 25
#define KB_Y 21
#define KB_Z 44
#define PGUP 73
#define PGDN 81
#define F1              59        
#define UP              72
#define DOWN            80
#define LEFT            75
#define RIGHT           77
#define TAB             15
#define ESC             1
#define CTRL            29
#define ALT             56
#define SPACE           57
#define MINUS           12
#define PLUS            13
#define INS             82
#define DEL             83
#define PAUSED          84
#define L_SHIFT         42
#define R_SHIFT         54

void    InitKey();
void    UninstallKey();

extern volatile char  key;
extern volatile char  keys[128];

#endif
