

'Simple engine for Pac Man game
'Using get/put etc
'If you have any questions/problems etc please email me at catforda@cobweb.com.au
'If you decide to use this code, and write anything decent please email me a copy!
'Andrew Catford Nov 25 1996.


DECLARE SUB drawlevel ()
DEFINT A-Z
        'Change to screen 9 (640 X 480 X 16, 2 flip screens)
        SCREEN 9
       
        'Define graphical arrays
        DIM Pac1(364), Pac2(364), Pac3(364), Pac4(364) 'Pacman sprites
        DIM Pac5(364), Pac6(364), Pac7(364), Pac8(364)
        DIM PacMask(364), PacMask2(364), PacMask3(364) 'Pacman masks
        DIM PacMask4(364), PacMask5(364)
        
        'Retrieve the Pacman sprites and masks
        GOSUB GetPac
       
        'Set the Co-ordinates
        x = 20
        y = 20
       
        'Set sprite direction
        d$ = "Right"

        'The keypress loop
        DO
                a$ = INKEY$ 'Get any keypress
                IF a$ = CHR$(77) THEN d$ = "Right" 'If 6 pressed, change direction
                IF a$ = CHR$(75) THEN d$ = "Left"  'If 4 pressed, change direction
                IF a$ = CHR$(72) THEN d$ = "Up"    'If 8 pressed...
                IF a$ = CHR$(80) THEN d$ = "Down"  'If 2 pressed...
                IF a$ = "6" THEN d$ = "Right" 'If 6 pressed, change direction
                IF a$ = "4" THEN d$ = "Left"  'If 4 pressed, change direction
                IF a$ = "8" THEN d$ = "Up"    'If 8 pressed, change direction
                IF a$ = "2" THEN d$ = "Down"  'If 2 pressed, change direction
                'IF UCASE$(a$) = "Q" THEN END 'break the loop and quit
                IF a$ = CHR$(27) THEN END 'break the loop and quit
                IF d$ = "Right" THEN x = x + 10 'move 10 pixels right
                IF d$ = "Left" THEN x = x - 10  'move 10 pixels left
                IF d$ = "Up" THEN y = y - 10    'move 10 pixels up
                IF d$ = "Down" THEN y = y + 10  'move 10 pixels down
                IF x < 1 THEN x = 1 'If they hit wall, stay there
                IF x > 600 THEN x = 600 ' If they hit wall, stay there
                IF y < 1 THEN y = 1 'If they hit roof...
                IF y > 480 THEN y = 480 'If they hit bottom...

                fm = 1 - fm 'Change frame (0 or 1)
                IF d$ = "Right" THEN
                        IF fm = 1 THEN
                                pg = 1 - pg 'Change screen
                                SCREEN 9, , pg, 1 - pg 'Flip the screens
                                WAIT &H3DA, 8 'Wait for electron beam
                                CLS
                                drawlevel 'draw background
                                PUT (x, y), PacMask, AND 'Paint mask
                                PUT (x, y), Pac1, XOR 'Paint sprite on mask
                                GOSUB waitt 'Wait for .1 of a second

                        ELSE
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x + 1, y), PacMask2, AND
                                PUT (x + 1, y), Pac2, XOR
                                GOSUB waitt
                        END IF
                END IF
                IF d$ = "Left" THEN
                        IF fm = 1 THEN
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x, y), PacMask, AND
                                PUT (x, y), Pac3, XOR
                                GOSUB waitt
                        ELSE
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x + 1, y), PacMask3, AND
                                PUT (x + 1, y), Pac4, XOR
                                GOSUB waitt
                        END IF
                END IF
                IF d$ = "Up" THEN
                        IF fm = 1 THEN
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x, y), PacMask, AND
                                PUT (x, y), Pac5, XOR
                                GOSUB waitt
                        ELSE
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x, y - 1), PacMask4, AND
                                PUT (x, y - 1), Pac6, XOR
                                GOSUB waitt
                        END IF
                END IF
                IF d$ = "Down" THEN
                        IF fm = 1 THEN
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x, y), PacMask, AND
                                PUT (x, y), Pac7, XOR
                                GOSUB waitt
                        ELSE
                                pg = 1 - pg
                                SCREEN 9, , pg, 1 - pg
                                WAIT &H3DA, 8
                                CLS
                                drawlevel
                                PUT (x, y - 1), PacMask5, AND
                                PUT (x, y - 1), Pac8, XOR
                                GOSUB waitt
                        END IF
                END IF
       
        LOOP
        END

GetPac:
'Pac1
x = 100: y = 100
CIRCLE (x, y), 15, 14
PAINT (x, y), 14
CIRCLE (x, y), 15, 0
GET (x - 17, y - 17)-(x + 17, y + 17), Pac1

'Pac2
x = 200
CIRCLE (x, y), 15, 14
PAINT (x, y), 14
PSET (x, y), 8
DRAW "e9;g9;f9"
PAINT (x + 5, y), 0, 8
GET (x - 17, y - 17)-(x + 17, y + 17), Pac2

'Pac3
x = 300
CIRCLE (x, y), 15, 14
PAINT (x, y), 14
GET (x - 17, y - 17)-(x + 17, y + 17), Pac3

'Pac4
x = 400
CIRCLE (x, y), 15, 8
PAINT (x, y), 14, 8
PSET (x, y), 8
DRAW "h9;f9;g9;e9"
PAINT (x - 5, y), 0, 8
CIRCLE (x, y), 15, 0
GET (x - 17, y - 17)-(x + 17, y + 17), Pac4

'Pac5
x = 100: y = 200
CIRCLE (x, y), 15, 14
PAINT (x, y), 14
CIRCLE (x, y), 0
GET (x - 17, y - 17)-(x + 17, y + 17), Pac5

'Pac6
x = 200
CIRCLE (x, y), 15, 8
PAINT (x, y), 14, 8
PSET (x, y), 8
DRAW "e9;g9;h9"
PAINT (x, y - 5), 0, 8
CIRCLE (x, y), 15, 0
GET (x - 17, y - 17)-(x + 17, y + 17), Pac6

'Pac7
x = 300
CIRCLE (x, y), 15, 14
PAINT (x, y), 14
GET (x - 17, y - 17)-(x + 17, y + 17), Pac7

'Pac8
x = 400
CIRCLE (x, y), 15, 8
PAINT (x, y), 14, 8
PSET (x, y), 8
DRAW "f9;h9;g9"
PAINT (x, y + 5), 0, 8
CIRCLE (x, y), 15, 0
GET (x - 17, y - 17)-(x + 17, y + 17), Pac8

'PacMask
x = 100: y = 300
CIRCLE (x, y), 15, 8
PAINT (x, y), 0, 8
PSET (x - 17, y - 17), 8
DRAW "r34;d34;l34;u34"
PAINT (x - 16, y - 16), 15, 8
CIRCLE (x, y), 15, 0
PSET (x - 17, y - 17), 15
DRAW "r34;d34;l34;u34"
CIRCLE (x, y), 15, 15
GET (x - 17, y - 17)-(x + 17, y + 17), PacMask

'PacMask2
x = 200
CIRCLE (x, y), 15, 8
PAINT (x, y), 0, 8
PSET (x - 17, y - 17), 8
DRAW "r34;d34;l34;u34"
PAINT (x - 16, y - 16), 15, 8
CIRCLE (x, y), 15, 0
PSET (x - 17, y - 17), 15
DRAW "r34;d34;l34;u34"
CIRCLE (x, y), 15, 15
PSET (x, y), 15
DRAW "e9;g9;f9"
PAINT (x + 5, y), 15
GET (x - 17, y - 17)-(x + 17, y + 17), PacMask2

'PacMask3
x = 300
CIRCLE (x, y), 15, 8
PAINT (x, y), 0, 8
PSET (x - 17, y - 17), 8
DRAW "r34;d34;l34;u34"
PAINT (x - 16, y - 16), 15, 8
CIRCLE (x, y), 15, 0
PSET (x - 17, y - 17), 15
DRAW "r34;d34;l34;u34"
CIRCLE (x, y), 15, 15
PSET (x, y), 15
DRAW "h9;f9;g9"
PAINT (x - 5, y), 15
GET (x - 17, y - 17)-(x + 17, y + 17), PacMask3

'PacMask4
x = 400
CIRCLE (x, y), 15, 8
PAINT (x, y), 0, 8
PSET (x - 17, y - 17), 8
DRAW "r34;d34;l34;u34"
PAINT (x - 16, y - 16), 15, 8
CIRCLE (x, y), 15, 0
PSET (x - 17, y - 17), 15
DRAW "r34;d34;l34;u34"
CIRCLE (x, y), 15, 15
PSET (x, y), 15
DRAW "e9;g9;h9"
PAINT (x, y - 5), 15
GET (x - 17, y - 17)-(x + 17, y + 17), PacMask4

'PacMask5
x = 500
CIRCLE (x, y), 15, 8
PAINT (x, y), 0, 8
PSET (x - 17, y - 17), 8
DRAW "r34;d34;l34;u34"
PAINT (x - 16, y - 16), 15, 8
CIRCLE (x, y), 15, 0
PSET (x - 17, y - 17), 15
DRAW "r34;d34;l34;u34"
CIRCLE (x, y), 15, 15
PSET (x, y), 15
DRAW "f9;h9;g9"
PAINT (x, y + 5), 15
GET (x - 17, y - 17)-(x + 17, y + 17), PacMask5

RETURN

waitt:
        T! = TIMER
        DO UNTIL TIMER > T! + .1
        LOOP
        RETURN

DEFINT A-Z







        SUB drawlevel
END SUB

