Here is Wanderer V3.2 for the Atari ST, compiled with the GNU C compiler,
v1.37.  Other than the changes outlined below, this port is identical
to the version distributed by the author, Steven Shipway.


Things I had to fudge to make it work
-------------------------------------

1) There were a couple of blatant syntax errors that had been carried over
   from a previous version.  It would appear that the C compiler used by
   the author was very flexible (or possibly not too clever.)

2) Fixed a bug in the password handling routines.  Certain dictionary
   file sizes caused the program to go into an endless loop.

3) The commandline option -C causes credits to be displayed continuouly.
   This section of code made use of a timing function that is not
   available for the ST.  I emulate the function with a for loop.


Things I did to make it better
------------------------------

1) Added a bit of code to allow the cursor keys to be used in addition
   to the standard movement keys "kjhl".  Also, the [HELP] key can be
   used in place of "?".

2) The program was originally designed to request a password when
   attempting to jump to a new level.  The given password was then
   compared to the password for each screen until either a match was
   found or the last screen was reached.  This method demanded that
   the program know how many screens were available.  This number was
   calculated each time the program was run by attempting to read screen.1,
   screen.2 etc. until a read failed.  Thus, there was an annoyingly long
   wait each time Wanderer was started up, while the program did 61 reads
   from disk (15-20 seconds on a hard drive, MUCH longer if running from
   floppy disk).

   The jump command now prompts for both the desired level and a
   password, eliminating the need to know how many screens there are.


Things that were totally unnecessary
------------------------------------

1) There were a few unused variables.  These have been removed.

2) The indenting of the code was often either misleading, or
   non-existant.  I indented everything in a consistent manner
   in an effort to make the code more readable.


Bugs (also known as thoughtful enhancements, features etc.)
-----------------------------------------------------------

None that I know of.  If you do find any, please drop me a line.  I can
be reached at the following address:

	bradr@uwovax.uwo.ca

regards,

Brad Robillard
